import { Component, ViewChild } from '@angular/core';

import { EMPLOYEE_DATA } from "./data";
import { IgxGridStateDirective } from 'igniteui-angular';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.scss']
})
export class AppComponent {
  title = 'kb4027-treegrid';

  @ViewChild(IgxGridStateDirective, { static: true }) public state: IgxGridStateDirective;

  public treeGridId = "tGrid1";
  public stateKey = this.treeGridId + "-state";
    public serialize = true;
  public localData: any[];

  constructor() {
    this.localData = EMPLOYEE_DATA;
  }

  public saveButtonClicked(){
    this.saveGridState();
  }

  public restoreButtonClicked(){
    this.restoreGridState();
  }

  public saveGridState() {
    const state = this.state.getState(this.serialize);
    if (typeof state === "string") {
      window.localStorage.setItem(this.stateKey, state);
    } else {
      window.localStorage.setItem(this.stateKey, JSON.stringify(state));
    }
  }

  public restoreGridState() {
    const state = window.localStorage.getItem(this.stateKey);
    if (state) {
      this.state.setState(state);
    }
  }
}
